#include <stdio.h>

#include <velib/base/base.h>
#include <velib/vecan/products.h>

typedef struct
{
	un16		prodId;
	const char *name;
} VeProduct;

static VeProduct const products[] =
{
	/*[[[cog
	import vepy.codegenerator
	vepy.codegenerator.codegen.array_content("meanings:victronenergy:product.ids")
	]]]*/
	{VE_PROD_ID_VENET_VPN, "VPN"},
	{VE_PROD_ID_VENET_VBC, "VBC"},
	{VE_PROD_ID_VENET_VVC, "VVC"},
	{VE_PROD_ID_VENET_VCC, "VCC"},
	{VE_PROD_ID_VENET_VCM, "VCM"},
	{VE_PROD_ID_VENET_VGM, "VGM"},
	{VE_PROD_ID_VENET_VRS, "VRS"},
	{VE_PROD_ID_VENET_FT, "Free Technics software"},
	{VE_PROD_ID_VENET_VBC_GMDSS, "VBC GMDSS"},
	{VE_PROD_ID_VENET_VPN_GMDSS, "VPM GMDSS"},
	{VE_PROD_ID_VENET_BPP, "BPP"},
	{VE_PROD_ID_VENET_VBC_48, "VBC 48V"},
	{VE_PROD_ID_VENET_VVC2, "VVC2"},
	{VE_PROD_ID_VENET_VBC_144, "VBC 144V"},
	{VE_PROD_ID_VENET_VBC2, "VBC2"},
	{VE_PROD_ID_VENET_VBC2_144, "VBC 144V"},
	{VE_PROD_ID_VENET_LYNX, "Lynx Shunt 1000A VE.Net"},
	{VE_PROD_ID_VECAN_BMV, "BMV to NMEA2000 interface"},
	{VE_PROD_ID_VECAN_SRP, "Skylla-i Control"},
	{VE_PROD_ID_VECAN_VHP, "Hybrid Panel"},
	{VE_PROD_ID_VECAN_MK2NMEA, "VE.Bus to NMEA2000 interface"},
	{VE_PROD_ID_VECAN_SKYLLA_I_24V_100A_1OUT, "Skylla-i 24/100 (1+1)"},
	{VE_PROD_ID_VECAN_SKYLLA_I_24V_80A_1OUT, "Skylla-i 24/80A (1+1)"},
	{VE_PROD_ID_VECAN_SKYLLA_I_24V_100A_3OUT, "Skylla-i 24/100 (3)"},
	{VE_PROD_ID_VECAN_SKYLLA_I_24V_80A_3OUT, "Skylla-i 24/80 (3)"},
	{VE_PROD_ID_VECAN_BLUE_SOLAR_MPPT_70A, "BlueSolar Charger MPPT 150/70"},
	{VE_PROD_ID_VECAN_LIC, "Ion Control"},
	{VE_PROD_ID_VECAN_LYNX_SHUNT, "Lynx Shunt 1000A VE.Can"},
	{VE_PROD_ID_VECAN_LYNX_ION, "Lynx Ion"},
	{VE_PROD_ID_BMV600S, "BMV-600S"},
	{VE_PROD_ID_BMV602S, "BMV-602S"},
	{VE_PROD_ID_BMV600HS, "BMV-600HS"},
	{VE_PROD_ID_BMV700, "BMV-700"},
	{VE_PROD_ID_BMV702, "BMV-702"},
	{VE_PROD_ID_BMV700H, "BMV-700H"},
	{VE_PROD_ID_BMVTEST, "BMV PCBA test firmware"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_70_15, "BlueSolar Charger MPPT 70/15"},
	{VE_PROD_ID_VEBUS_REMOTE_PANEL_9912, "Remote panel"},
	{VE_PROD_ID_VEBUS_REMOTE_PANEL_20MHZ_9915, "Remote panel 20MHz"},
	{VE_PROD_ID_VEBUS_REMOTE_PANEL_DONGLE_20MHZ_9915, "Remote panel Dongle 20MHz"},
	{VE_PROD_ID_VEBUS_MK2_20MHZ_9915, "MK2 20Mhz"},
	{VE_PROD_ID_VEBUS_MK2_DONGLE_20MHZ_9915, "MK2 Dongle 20Mhz"},
	{VE_PROD_ID_VEBUS_VE_BUS_RESETTER__BASED_ON_MK2__20_MHZ_9915, "VE.Bus Resetter (based on MK2) 20 Mhz"},
	{VE_PROD_ID_VEBUS_MK2_TACHOMETER_20MHZ_9916, "MK2 tachometer 20Mhz"},
	{VE_PROD_VEBUS_BMS, "BMS 20Mhz"},
	{VE_PROD_ID_VEBUS_SOLAR_SWITCH_BOX_9918, "Solar switch box"},
	{VE_PROD_ID_VEBUS_USB_VEBUS_GRABBER_9919, "USB VEBus grabber"},
	{VE_PROD_ID_MK3, "MK3"},
	{VE_PROD_ID_VEBUS_PHOENIX_CHARGER_12_100_9911, "Phoenix Charger 12/100"},
	{VE_PROD_ID_VEBUS_PHOENIX_CHARGER_12_200_9911, "Phoenix Charger 12/200"},
	{VE_PROD_ID_VEBUS_PHOENIX_CHARGER_24_50_9911, "Phoenix Charger 24/50"},
	{VE_PROD_ID_VEBUS_PHOENIX_CHARGER_24_100_9911, "Phoenix Charger 24/100"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_12V_FULL_POWER_9901, "Phoenix Multi 12V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_12V_HALF_POWER_9901, "Phoenix Multi 12V half power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_12V_FULL_POWER_9901, "Phoenix MultiPlus 12V full power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_12V_LOW_POWER_9900, "MultiCompact 12V low power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_12V_MEDIUM_POWER_9900, "MultiCompact 12V medium power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_12V_HIGH_POWER_9900, "MultiCompact 12V high power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_12V_HIGH_POWER_9900, "MultiCompactPlus 12V high power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_12V_MEDIUM_POWER_9900, "MultiCompactPlus 12V medium power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_24V_FULL_POWER_9901, "Phoenix Multi 24V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_24V_HALF_POWER_9901, "Phoenix Multi 24V half power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_24V_FULL_POWER_9901, "Phoenix MultiPlus 24V full power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_24V_LOW_POWER_9900, "MultiCompact 24V low power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_24V_MEDIUM_POWER_9900, "MultiCompact 24V medium power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_24V_HIGH_POWER_9900, "MultiCompact 24V high power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_24V_HIGH_POWER_9900, "MultiCompactPlus 24V high power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_24V_MEDIUM_POWER_9900, "MultiCompactPlus 24V medium power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_120_12V_FULL_POWER_9901, "Phoenix Multi 120 12V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_120_12V_HALF_POWER_9901, "Phoenix Multi 120 12V half power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_120_12V_FULL_POWER_9901, "Phoenix MultiPlus 120 12V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_120_24V_FULL_POWER_9901, "Phoenix Multi 120 24V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_120_24V_HALF_POWER_9901, "Phoenix Multi 120 24V half power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_120_24V_FULL_POWER_9901, "Phoenix MultiPlus 120 24V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_48V_FULL_POWER_9901, "Phoenix Multi 48V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_48V_HALF_POWER_9901, "Phoenix Multi 48V half power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_48V_FULL_POWER_9901, "Phoenix MultiPlus 48V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_12V_FULL_POWER_9906, "Phoenix Multi 12V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_12V_HALF_POWER_9906, "Phoenix Multi 12V half power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_12V_FULL_POWER_9906, "Phoenix MultiPlus 12V full power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_12V_LOW_POWER_9902, "MultiCompact 12V low power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_12V_MEDIUM_POWER_9902, "MultiCompact 12V medium power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_12V_HIGH_POWER_9902, "MultiCompact 12V high power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_12V_HIGH_POWER_9902, "MultiCompactPlus 12V high power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_12V_MEDIUM_POWER_9902, "MultiCompactPlus 12V medium power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_12V_2000_9906, "Phoenix MultiPlus 12V/2000"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_12V_3000_9906, "Phoenix MultiPlus 12V/3000"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_24V_FULL_POWER_9906, "Phoenix Multi 24V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_24V_HALF_POWER_9906, "Phoenix Multi 24V half power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_24V_FULL_POWER_9906, "Phoenix MultiPlus 24V full power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_24V_LOW_POWER_9902, "MultiCompact 24V low power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_24V_MEDIUM_POWER_9902, "MultiCompact 24V medium power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACT_24V_HIGH_POWER_9902, "MultiCompact 24V high power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_24V_HIGH_POWER_9902, "MultiCompactPlus 24V high power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_24V_MEDIUM_POWER_9902, "MultiCompactPlus 24V medium power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_24V_2000_9906, "Phoenix MultiPlus 24V/2000"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_120_12V_FULL_POWER_9906, "Phoenix Multi 120 12V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_120_12V_HALF_POWER_9906, "Phoenix Multi 120 12V half power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_120_12V_FULL_POWER_9906, "Phoenix MultiPlus 120 12V full power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_120_12V_HIGH_POWER_9906, "MultiCompactPlus 120 12V high power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_120_12V_3000_9906, "Phoenix MultiPlus 120 12V/3000"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_120_24V_FULL_POWER_9906, "Phoenix Multi 120 24V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_120_24V_HALF_POWER_9906, "Phoenix Multi 120 24V half power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_120_24V_FULL_POWER_9906, "Phoenix MultiPlus 120 24V full power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_120_24V_HIGH_POWER_9906, "MultiCompactPlus 120 24V high power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_48V_FULL_POWER_9906, "Phoenix Multi 48V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_48V_HALF_POWER_9906, "Phoenix Multi 48V half power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_48V_FULL_POWER_9906, "Phoenix MultiPlus 48V full power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_48V_HIGH_POWER_9906, "MultiCompactPlus 48V high power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_120_48V_FULL_POWER_9906, "Phoenix MultiPlus 120 48V full power"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_12V_2K_9906, "MultiCompactPlus 12V 2K"},
	{VE_PROD_ID_VEBUS_MULTICOMPACTPLUS_24V_2K_9906, "MultiCompactPlus 24V 2K"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_12_3000_120_50_9906, "MultiPlus 12/3000/120-50"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_12_3000_120_30_9906, "MultiPlus 12/3000/120-30"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_12V_FULL_POWER, "Phoenix MultiPlus 12V full power"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_COMPACT_12_800_35_16_9906, "Phoenix Multi Compact 12/800/35-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_12_1600_70_16_9906, "MultiPlus Compact 12/1600/70-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_12_1200_50_16_9906, "MultiPlus Compact 12/1200/50-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_12_2000_80_30_9906, "MultiPlus Compact 12/2000/80-30"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_12_3000_120_16_9906, "MultiPlus 12/3000/120-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_24_3000_70_50_9906, "MultiPlus 24/3000/70-50"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_24_3000_70_30_9906, "MultiPlus 24/3000/70-30"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_24_3000_70_16_9906, "MultiPlus 24/3000/70-16"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTI_COMPACT_24_800_16_16_9906, "Phoenix Multi Compact 24/800/16-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_24_1600_40_16_9906, "MultiPlus Compact 24/1600/40-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_24_1200_25_16_9906, "MultiPlus Compact 24/1200/25-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_24_2000_50_30_9906, "MultiPlus Compact 24/2000/50-30"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_48_3000_35_50_9906, "MultiPlus 48/3000/35-50"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_48_3000_35_30_9906, "MultiPlus 48/3000/35-30"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_48_3000_35_16_9906, "MultiPlus 48/3000/35-16"},
	{VE_PROD_ID_VEBUS_QUATTRO_12_5000_200_2X30_9906, "Quattro 12/5000/200-2x30"},
	{VE_PROD_ID_VEBUS_QUATTRO_12_3000_120_50_30_9906, "Quattro 12/3000/120-50/30"},
	{VE_PROD_ID_VEBUS_QUATTRO_12_5000_200_50_30_9906, "Quattro 12/5000/200-50/30"},
	{VE_PROD_ID_VEBUS_QUATTRO_12_5000_220_2X75_9906, "Quattro 12/5000/220-2x75"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_5000_120_2X30_9906, "Quattro 24/5000/120-2x30"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_3000_70_50_30_9906, "Quattro 24/3000/70-50/30"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_5000_120_50_30_9906, "Quattro 24/5000/120-50/30"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_8000_200_2X100_9906, "Quattro 24/8000/200-2x100"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_5000_120_2X100_9906, "Quattro 24/5000/120-2x100"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_24_5000_120_50_9906, "MultiPlus 24/5000/120-50"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_5000_70_2X30_9906, "Quattro 48/5000/70-2x30"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_5000_70_50_30_9906, "Quattro 48/5000/70-50/30"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_10000_140_2X100_9906, "Quattro 48/10000/140-2x100"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_8000_110_2X100_9906, "Quattro 48/8000/110-2x100"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_5000_70_2X100_9906, "Quattro 48/5000/70-2x100"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_48_5000_70_50_9906, "MultiPlus 48/5000/70-50"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_12_3000_120_50_120V_9906, "MultiPlus 12/3000/120-50 120V"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_12_2000_80_50_120V_9906, "MultiPlus Compact 12/2000/80-50 120V"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_120_12V_3000, "Phoenix MultiPlus 120 12V/3000"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_24_3000_70_50_120V_9906, "MultiPlus 24/3000/70-50 120V"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_24_2000_50_50_120V_9906, "MultiPlus Compact 24/2000/50-50 120V"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_120_48V_3000_9906, "Phoenix MultiPlus 120 48V/3000"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_5000_120_2X100_120V_9906, "Quattro 24/5000/120-2x100 120V"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_3000_35_2X50_120V_9906, "Quattro 48/3000/35-2x50 120V"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_5000_70_2X100_120V_9906, "Quattro 48/5000/70-2x100 120V"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_120_48V_5000_9906, "Phoenix MultiPlus 120 48V/5000"},
	{VE_PROD_ID_VEBUS_PHOENIX_12_3000_120_50_120_240V_9906, "Phoenix 12/3000/120-50-120/240V"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_12_2000_80_50_30__120_240V_9906, "MultiPlus Compact 12/2000/80-50(30)-120/240V"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_5000_120_2X60_120_240V_9906, "Quattro 24/5000/120-2x60-120/240V"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_24_2000_50_50_30__120_240V_9906, "MultiPlus Compact 24/2000/50-50(30)-120/240V"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_120_240_48V_3000_WITH_50A_AC_RELAIS_9906, "Phoenix MultiPlus 120/240 48V/3000 with 50A AC relais"},
	{VE_PROD_ID_VEBUS_PHOENIX_HF_9915, "Phoenix HF"},
	{VE_PROD_ID_VEBUS_PHOENIX_12_800, "Phoenix 12/800"},
	{VE_PROD_ID_VEBUS_PHOENIX_12_1200, "Phoenix 12/1200"},
	{VE_PROD_ID_VEBUS_PHOENIX_24_800, "Phoenix 24/800"},
	{VE_PROD_ID_VEBUS_PHOENIX_24_1200, "Phoenix 24/1200"},
	{VE_PROD_ID_VEBUS_PHOENIX_48_800, "Phoenix 48/800"},
	{VE_PROD_ID_VEBUS_PHOENIX_48_1200, "Phoenix 48/1200"},
	{VE_PROD_ID_VEBUS_PHOENIX_12_800_120V, "Phoenix 12/800 120V"},
	{VE_PROD_ID_VEBUS_PHOENIX_12_1200_120V, "Phoenix 12/1200 120V"},
	{VE_PROD_ID_VEBUS_PHOENIX_24_800_120V, "Phoenix 24/800 120V"},
	{VE_PROD_ID_VEBUS_PHOENIX_24_1200_120V, "Phoenix 24/1200 120V"},
	{VE_PROD_ID_VEBUS_PHOENIX_48_800_120V, "Phoenix 48/800 120V"},
	{VE_PROD_ID_VEBUS_PHOENIX_48_1200_120V, "Phoenix 48/1200 120V"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_12_3000_120_50, "MultiPlus 12/3000/120-50"},
	{VE_PROD_ID_VEBUS_PHOENIX_MULTIPLUS_COMPACT_12_800_35_15, "Phoenix Multi Compact 12/800/35-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_12_1600_70_16, "MultiPlus Compact 12/1600/70-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_12_1200_50_16, "MultiPlus Compact 12/1200/50-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_12_2000_80_30, "MultiPlus Compact 12/2000/80-30"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_12_3000_120_16, "MultiPlus 12/3000/120-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_24_3000_70_50, "MultiPlus 24/3000/70-50"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_24_3000_70_16, "MultiPlus 24/3000/70-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_24_800_16_16, "Phoenix Multi Compact 24/800/16-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_24_5000_120_100, "MultiPlus 24/5000/120-100"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_24_1600_40_16, "MultiPlus Compact 24/1600/40-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_24_1200_25_16, "MultiPlus Compact 24/1200/25-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_24_2000_50_30, "MultiPlus Compact 24/2000/50-30"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_48_3000_35_50, "MultiPlus 48/3000/35-50"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_48_3000_35_16, "MultiPlus 48/3000/35-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_48_5000_70_100, "MultiPlus 48/5000/70-100"},
	{VE_PROD_ID_VEBUS_QUATTRO_12_3000_120_50_30, "Quattro 12/3000/120-50/30"},
	{VE_PROD_ID_VEBUS_QUATTRO_12_5000_220, "Quattro 12/5000/220-2x75"},
	{VE_PROD_ID_VEBUS_QUATTRO_12_3000_120, "Quattro 12/3000/120-2x50"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_3000_70_50_30, "Quattro 24/3000/70-50/30"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_5000_120_50_30, "Quattro 24/5000/120-50/30"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_8000_200_100_100, "Quattro 24/8000/200-2x100"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_3000_70_50_50, "Quattro 24/3000/70-2x50"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_5000_120_100_100, "Quattro 24/5000/120-2x100"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_48_5000_120_50, "MultiPlus 24/5000/120-50"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_5000_70_50_30, "Quattro 48/5000/70-50/30"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_10000_140_100_100, "Quattro 48/10000/140-2x100"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_8000_110_100_100, "Quattro 48/8000/110-2x100"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_8000_110_100_100_REV2, "Quattro 48/8000/110-2x100"},
	{VE_PROD_ID_VEBUS_QUATTRO_S_48_5000_70_100_100, "Quattro 48/5000/70-2x100-S"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_5000_70_100_100, "Quattro 48/5000/70-2x100"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_48_5000_70_50, "MultiPlus 48/5000/70-50"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_12_500_20_16, "MultiPlus 12/500/20-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_12_800_20_16, "MultiPlus 12/800/20-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_24_500_10_16, "MultiPlus 24/500/10-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_24_800_10_16, "MultiPlus 24/800/10-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_48_500_6_16, "MultiPlus 48/500/6-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_48_800_6_16, "MultiPlus 48/800/6-16"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_12_3000_120_50_120V, "MultiPlus 12/3000/120-50 120V"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_12_2000_80_50_120V, "MultiPlus Compact 12/2000/80-50 120V"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_24_3000_70_50_120V, "MultiPlus 24/3000/70-50 120V"},
	{VE_PROD_ID_VEBUS_MULTIPLUS_COMPACT_24_2000_50_50_120V, "MultiPlus Compact 24/2000/50-50 120V"},
	{VE_PROD_ID_VEBUS_QUATTRO_12_5000_120_100_100_120V, "Quattro 12/5000/120-2x100 120V"},
	{VE_PROD_ID_VEBUS_QUATTRO_24_5000_120_100_100_120V, "Quattro 24/5000/120-2x100 120V"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_3000_35_50_50_120V, "Quattro 48/3000/35-2x50 120V"},
	{VE_PROD_ID_VEBUS_QUATTRO_48_5000_70_100_100_120V, "Quattro 48/5000/70-2x100 120V"},
	{VE_PROD_ID_VECAN_SKYLLA_IP44, "Skylla-IP44 battery charger"},
	{VE_PROD_ID_VECAN_SKYLLA_IP44_12V_60A_1OUT_230V, "Skylla-IP44 12V/60A (1+1)"},
	{VE_PROD_ID_VECAN_SKYLLA_IP44_12V_60A_3OUT_230V, "Skylla-IP44 12V/60A (3)"},
	{VE_PROD_ID_VECAN_SKYLLA_IP44_12V_60A_1OUT_FM, "Skylla-IP44 12V/60A (1+1)"},
	{VE_PROD_ID_VECAN_SKYLLA_IP44_12V_60A_3OUT_FM, "Skylla-IP44 12V/60A (3)"},
	{VE_PROD_ID_VECAN_SKYLLA_IP44_24V_30A_1OUT_230V, "Skylla-IP44 24V/30A (1+1)"},
	{VE_PROD_ID_VECAN_SKYLLA_IP44_24V_30A_3OUT_230V, "Skylla-IP44 24V/30A (3)"},
	{VE_PROD_ID_VECAN_SKYLLA_IP44_24V_30A_1OUT_FM, "Skylla-IP44 24V/30A (1+1)"},
	{VE_PROD_ID_VECAN_SKYLLA_IP44_24V_30A_3OUT_FM, "Skylla-IP44 24V/30A (3)"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_75_50, "BlueSolar Charger MPPT 75/50"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_150_35, "BlueSolar Charger MPPT 150/35 rev1"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_75_15, "BlueSolar Charger MPPT 75/15"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_100_15, "BlueSolar Charger MPPT 100/15"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_100_30, "BlueSolar Charger MPPT 100/30 rev1"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_100_50, "BlueSolar Charger MPPT 100/50 rev1"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_150_70, "BlueSolar Charger MPPT 150/70"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_150_100, "BlueSolar Charger MPPT 150/100"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_75_50_REV2, "BlueSolar Charger MPPT 75/50 rev2"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_100_50_REV2, "BlueSolar Charger MPPT 100/50 rev2"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_100_30_REV2, "BlueSolar Charger MPPT 100/30 rev2"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_150_35_REV2, "BlueSolar Charger MPPT 150/35 rev2"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_75_10, "BlueSolar Charger MPPT 75/10"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_150_45, "BlueSolar Charger MPPT 150/45"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_150_60, "BlueSolar Charger MPPT 150/60"},
	{VE_PROD_ID_BLUE_SOLAR_MPPT_150_85, "BlueSolar Charger MPPT 150/85"},
	{VE_PROD_ID_SMART_SOLAR_MPPT_250_100, "SmartSolar Charger MPPT 250/100"},
	{VE_PROD_ID_SMART_SOLAR_MPPT_150_100, "SmartSolar Charger MPPT 150/100"},
	{VE_PROD_ID_SMART_SOLAR_MPPT_150_85, "SmartSolar Charger MPPT 150/85"},
	{VE_PROD_ID_SMART_SOLAR_MPPT_75_15, "SmartSolar Charger MPPT 75/15"},
	{VE_PROD_ID_SMART_SOLAR_MPPT_75_10, "SmartSolar Charger MPPT 75/10"},
	{VE_PROD_ID_SMART_SOLAR_MPPT_100_15, "SmartSolar Charger MPPT 100/15"},
	{VE_PROD_ID_SMART_SOLAR_MPPT_100_30, "SmartSolar Charger MPPT 100/30"},
	{VE_PROD_ID_SMART_SOLAR_MPPT_100_50, "SmartSolar Charger MPPT 100/50"},
	{VE_PROD_ID_SMART_SOLAR_MPPT_150_35, "SmartSolar Charger MPPT 150/35"},
	{VE_PROD_ID_LITHIUM_BALANCER, "Lithium Battery Balancer"},
	{VE_PROD_ID_SMART_LITHIUM_12V_90AH, "Smart Lithium Battery 12.8V/90Ah"},
	{VE_PROD_ID_SMART_LITHIUM_12V_60AH, "Smart Lithium Battery 12.8V/60Ah"},
	{VE_PROD_ID_VECAN_BSRP, "BlueSolar Remote Panel"},
	{VE_PROD_ID_VECAN_BLUE_SOLAR_MPPT_85A, "BlueSolar Charger MPPT 150/85"},
	{VE_PROD_ID_VECAN_MK2NMEA_REV2, "VE.Bus to NMEA2000 interface (rev2)"},
	{VE_PROD_ID_VECAN_VEDIRECT, "VE.Direct to CAN interface"},
	{VE_PROD_ID_VECAN_LYNX_ION_SHUNT, "Lynx Ion + Shunt"},
	{VE_PROD_ID_PV_INVERTER_QWACS, "PV Inverter (QWACS)"},
	{VE_PROD_ID_PV_INVERTER_VEBUS, "PV Inverter (AC Current Sensor)"},
	{VE_PROD_ID_PV_INVERTER_FRONIUS, "Fronius solar inverters"},
	{VE_PROD_ID_TANK_SENSOR, "Tank sensor"},
	{VE_PROD_ID_TANK_SENSOR_INPUT, "Generic Tank Input"},
	{VE_PROD_ID_TEMPERATURE_SENSOR_INPUT, "Generic Temperature Input"},
	{VE_PROD_ID_MPPT_CONTROL, "Mppt control"},
	{VE_PROD_ID_MPPT_CONTROL_TEST, "Mppt control PCBA test firmware"},
	{VE_PROD_ID_VEDIRECT_PPP_12V_8AH, "Peak Power Pack 12V 8Ah"},
	{VE_PROD_ID_VEDIRECT_PPP_TEST, "Peak Power Pack PCBA test firmware"},
	{VE_PROD_ID_VEDIRECT_SMART_DONGLE, "VE.Direct Bluetooth Smart Dongle"},
	{VE_PROD_ID_VEDIRECT_DONGLE_BL_SD_V7, "Bootloader for softdevice v7"},
	{VE_PROD_ID_VEDIRECT_DONGLE_LEGACY_V1, "Virtual id for v1 legacy dongle"},
	{VE_PROD_ID_VEDIRECT_PPP_12V_20AH, "Peak Power Pack 12V 20Ah"},
	{VE_PROD_ID_VEDIRECT_PPP_12V_30AH, "Peak Power Pack 12V 30Ah"},
	{VE_PROD_ID_VEDIRECT_PPP_12V_40AH, "Peak Power Pack 12V 40Ah"},
	{VE_PROD_ID_SMARTSOLAR_DONGLE, "SmartSolar Bluetooth Interface"},
	{VE_PROD_ID_PHOENIX_INVERTER, "Phoenix Inverter"},
	{VE_PROD_ID_PHOENIX_INVERTER_12V_250VA, "Phoenix Inverter 12V 250VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_24V_250VA, "Phoenix Inverter 24V 250VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_48V_250VA, "Phoenix Inverter 48V 250VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_12V_375VA, "Phoenix Inverter 12V 375VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_24V_375VA, "Phoenix Inverter 24V 375VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_48V_375VA, "Phoenix Inverter 48V 375VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_12V_500VA, "Phoenix Inverter 12V 500VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_24V_500VA, "Phoenix Inverter 24V 500VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_48V_500VA, "Phoenix Inverter 48V 500VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_12V_250VA_64K, "Phoenix Inverter 12V 250VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_24V_250VA_64K, "Phoenix Inverter 24V 250VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_48V_250VA_64K, "Phoenix Inverter 48V 250VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_12V_375VA_64K, "Phoenix Inverter 12V 375VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_24V_375VA_64K, "Phoenix Inverter 24V 375VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_48V_375VA_64K, "Phoenix Inverter 48V 375VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_12V_500VA_64K, "Phoenix Inverter 12V 500VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_24V_500VA_64K, "Phoenix Inverter 24V 500VA 230V"},
	{VE_PROD_ID_PHOENIX_INVERTER_48V_500VA_64K, "Phoenix Inverter 48V 500VA 230V"},
	{VE_PROD_ID_BSC, "Generic id"},
	{VE_PROD_ID_BSC_IP65_12_10, "Blue Smart IP65 Charger 12|10"},
	{VE_PROD_ID_BSC_IP65_12_15, "Blue Smart IP65 Charger 12|15"},
	{VE_PROD_ID_BSC_IP65_24_8, "Blue Smart IP65 Charger 24|8"},
	{VE_PROD_ID_BSC_IP65_12_5, "Blue Smart IP65 Charger 12|5"},
	{VE_PROD_ID_BSC_IP65_12_7, "Blue Smart IP65 Charger 12|7"},
	{VE_PROD_ID_BSC_IP65_24_5, "Blue Smart IP65 Charger 24|5"},
	{VE_PROD_ID_BSC_IP65_12_4, "Blue Smart IP65 Charger 12|4"},
	{VE_PROD_ID_BSC_IP67_12_7, "Blue Smart IP67 Charger 12|7"},
	{VE_PROD_ID_BSC_IP67_12_13, "Blue Smart IP67 Charger 12|13"},
	{VE_PROD_ID_BSC_IP67_24_5, "Blue Smart IP67 Charger 24|5"},
	{VE_PROD_ID_BSC_IP67_12_17, "Blue Smart IP67 Charger 12|17"},
	{VE_PROD_ID_BSC_IP67_12_25, "Blue Smart IP67 Charger 12|25"},
	{VE_PROD_ID_BSC_IP67_24_8, "Blue Smart IP67 Charger 24|8"},
	{VE_PROD_ID_BSC_IP67_24_12, "Blue Smart IP67 Charger 24|12"},
	{VE_PROD_ID_BSC_IP22_12_15_1, "Blue Smart IP22 Charger 12|15 (1)"},
	{VE_PROD_ID_BSC_IP22_12_15_3, "Blue Smart IP22 Charger 12|15 (3)"},
	{VE_PROD_ID_BSC_IP22_12_20_1, "Blue Smart IP22 Charger 12|20 (1)"},
	{VE_PROD_ID_BSC_IP22_12_20_3, "Blue Smart IP22 Charger 12|20 (3)"},
	{VE_PROD_ID_BSC_IP22_12_30_1, "Blue Smart IP22 Charger 12|30 (1)"},
	{VE_PROD_ID_BSC_IP22_12_30_3, "Blue Smart IP22 Charger 12|30 (3)"},
	{VE_PROD_ID_BSC_IP22_24_8_1, "Blue Smart IP22 Charger 24|8 (1)"},
	{VE_PROD_ID_BSC_IP22_24_8_3, "Blue Smart IP22 Charger 24|8 (3)"},
	{VE_PROD_ID_BSC_IP22_24_12_1, "Blue Smart IP22 Charger 24|12 (1)"},
	{VE_PROD_ID_BSC_IP22_24_12_3, "Blue Smart IP22 Charger 24|12 (3)"},
	{VE_PROD_ID_BSC_IP22_24_16_1, "Blue Smart IP22 Charger 24|16 (1)"},
	{VE_PROD_ID_BSC_IP22_24_16_3, "Blue Smart IP22 Charger 24|16 (3)"},
	{VE_PROD_ID_BPC, "Generic id"},
	{VE_PROD_ID_BPC_IP65_12_10, "Blue Power IP65 Charger 12|10"},
	{VE_PROD_ID_BPC_IP65_12_15, "Blue Power IP65 Charger 12|15"},
	{VE_PROD_ID_BPC_IP65_24_8, "Blue Power IP65 Charger 24|8"},
	{VE_PROD_ID_BPC_IP65_12_5, "Blue Power IP65 Charger 12|5"},
	{VE_PROD_ID_BPC_IP65_12_7, "Blue Power IP65 Charger 12|7"},
	{VE_PROD_ID_BPC_IP65_24_5, "Blue Power IP65 Charger 24|5"},
	{VE_PROD_ID_VALENCE_XP_BATTERY, "Valence XP Battery"},
	{VE_PROD_ID_VALENCE_BMS, "Valence BMS"},
	{VE_PROD_ID_CARLO_GAVAZZI_EM, "Carlo Gavazzi Energy Meter"},
	{VE_PROD_ID_REDFLOW_ZBM2, "Redflow ZBM 2 Battery"},
	{VE_PROD_ID_LG_RESU_BATTERY, "LG resu battery"},
	{VE_PROD_ID_BMZ_BATTERY, "BMZ battery"},
	{VE_PROD_ID_CARLO_GAVAZZI_PIGGY_BACK, "Carlo Gavazzi virtual PV Inverter"},
	{VE_PROD_ID_SW_VEDIRECT_INTERFACE, "sw vedirect interface"},
	{VE_PROD_ID_SW_BASE, "sw base"},
	{VE_PROD_ID_SW_BLE_INTERFACE, "sw ble interface"},
	{VE_PROD_ID_SW_MASK, "sw mask, not a product...."},
	{VE_PROD_RESERVED, "reserved"},
	{VE_PROD_NOT_SET, "No product set"}
	/*[[[end]]]*/
};

const char *veProductGetName(un16 prodId)
{
	size_t i;

	for (i = 0; i < ARRAY_LENGTH(products); i++)
	{
		if (products[i].prodId == prodId)
			return products[i].name;
	}

	return NULL;
}
