#ifndef _MSG_ROUTER_H_
#define _MSG_ROUTER_H_

#include <velib/base/base.h>
#include <velib/utils/ve_events.h>
#include <velib/J1939/J1939_function.h>
#include <velib/nmea2k/n2k.h>
#include <velib/vecan/reg_rx.h>


typedef void msgRouterRxFun(void *ctx, struct J1939Func *src);
typedef void msgRouterFoundFun(void *ctx, struct J1939Func *src);
typedef void msgRouterVregFun(void *ctx, struct J1939Func *src,
								VeEvent ev, VeRegId id, VeRegAckCode code);


typedef struct MsgRouterHookS
{
	struct MsgRouterHookS *next;

	msgRouterRxFun *rxFun;
	msgRouterVregFun *vregFun;
	void *ctx;

	struct J1939Func *func;
} MsgRouterHook;

void msgRouterInit(struct VeItem *mainNad);
void msgRouterUpdate(void);
void msgRouterTick(void);
void msgRouterAddHook(MsgRouterHook* hook);
void msgRouterRemoveHook(MsgRouterHook *hook);

void msgRouterInstanceChanged(struct J1939Func* func);

#endif
