#ifndef _CANBUS_SENDERS_H_
#define _CANBUS_SENDERS_H_

#include <velib/base/types.h>
#include <velib/types/ve_item.h>

struct VLinkDeviceS;

/** Fake a multi and forward the link voltage setpoint, so solar chargers can use it */
typedef struct VLinkDeviceS
{
	J1939DeviceTp j1939Dev;
	VeItem *linkVoltageSetPoint;
} VLinkDevice;

/* Devices sending data towards the CAN-bus, these will be found again as well */
void veCanAddSendingDevice(struct J1939Device *device);
veBool veCanIsLocalSender(struct J1939Func *listeningDev);

VLinkDevice *vLinkNewInstance(un32 unique, VeItem *instance, VeItem *nad, VeItem *hub1Setpoint);
void mainDeviceAdd(un32 unique, VeItem *nad);
void mainDeviceActivate(void);

#endif
