#ifndef _VALUES_LYNXION_H_
#define _VALUES_LYNXION_H_

#include <velib/types/ve_item.h>

#include <values_common.h>

typedef struct {
	un16 pollTimer;
	veBool getHistory;
	veBool getProductInfo;
	veBool getBmsInfo;
	veBool getSystem;
	veBool getDiagnostics;

	/* For sub systems */
	MsgRouterHook hooks;
} VeCanLynxIon;

typedef struct
{
	VeItem minCellVoltage;
	VeItem maxCellVoltage;
} HistoryLynxIon;

typedef struct VeLynxIonS
{
	VeCanLynxIon can;

	VeItem state;
	VeItem error;
	VeItem systemSwitch;
	VeItem balancing;
	VeItem nrOfBatteries;
	VeItem batteriesParallel;
	VeItem batteriesSeries;
	VeItem nrOfCellsPerBattery;
	VeItem minCellVoltage;
	VeItem maxCellVoltage;
	VeItem shutdownsDueError;
	VeItem lastError1;
	VeItem lastError2;
	VeItem lastError3;
	VeItem lastError4;
	VeItem allowToCharge;
	VeItem allowToDischarge;
	VeItem externalRelay;
	HistoryLynxIon history;
} VeLynxIon;

veBool valuesLynxIonInit(VeSystem *system);
veBool valuesLynxIonBatteryInit(VeSystem *system);

#endif
