#ifndef VALUES_VEBUS_H
#define VALUES_VEBUS_H

#include <velib/types/ve_item.h>
#include <velib/mk2/vebus_items.h>
#include <velib/platform/serial.h>
#include <velib/io/ve_remote_device_item.h>
#include <velib/io/ve_remote_device_vecan.h>

#include <values_common.h>

typedef struct {
	veBool sendEnableFeatures;
	un32 remoteControl;
	un32 pollTimer;
	veBool reqVregs;
	veBool getProductInfo;
	veBool getDcDetails;
	veBool getVeBusError;
} VeBusCan;

typedef struct VeBusSysS
{
	VeBusCan can;
	struct J1939Func *acInput;
	VeBusItems items;

	/* Vebus version number consists of productId and versions. They are received seperatly as bcd */
	VeItem masterProductId;
	VeItem masterVersionPart;
	VeItem masterVersion;

	VeItem mk2ProductId;
	VeItem mk2VersionPart;
	VeItem mk2Version;

	VeItem dmcProductId;
	VeItem dmcVersionPart;
	VeItem dmcVersion;

	VeItem bmsProductId;
	VeItem bmsVersionPart;
	VeItem bmsVersion;

	VeItem alarms[4];

	VeItem hub1VoltageSetPoint;

	un8 numberOfPhases;

	struct VeCanRemoteDev mk2Can;
	struct VeItemRemoteDev mk2Dbus;
} VeBusSys;

veBool valuesVebusInit(VeSystem *system);

#endif
