#ifndef _VECAN_COMMON_H_
#define _VECAN_COMMON_H_

#include <velib/io/ve_stream_items.h>
#include <velib/J1939/J1939_function.h>
#include <velib/J1939/J1939_types.h>
#include <velib/types/ve_item.h>
#include <velib/utils/ve_events.h>

#include <values_common.h>

// DC Types in DC Detailed Status (PGN 127506)
#define DC_TYPE_BATTERY		0x00
#define DC_TYPE_SOLAR_CELL	0x03

//void veInVregFirmwareVersion(VeItem *item);

veBool veCanSetDeviceInstance(struct J1939Func *dev, un8 instance);
veBool veCanSetVeReg(VeSystem *system, VeVariant *variant, VeSetting *setting);
veBool veCanIsElectricalFunction(struct J1939Func *func, N2kFunctionElectrical function);

void veMsgHandlerVeRegs(VeEvent ev);
void veCanbusCommonTick(void);
void veCanCheckForNewDevice(struct J1939Func *dev);
void veCanNewDeviceCallback(struct J1939Func *dev);
void veCanInstanceChangedCallback(struct J1939Func *dev);
un32 veCanCountDevices(VeSystem *system);
un32 veCanCountMasters(VeSystem *system);
VeSystem *veCanRemoveSystem(VeSystem *system);

un32 decimalToHex(un32 version);
void veInTemperatureInCelsius(VeItem *item);
void veInAlarm(VeItem *item);
void veInSetting(VeSetting *settings, VeRegId id, void *src);

#endif
