#include <velib/types/ve_dbus_item.h>
#include <velib/utils/ve_logger.h>

#include <dbus_service.h>
#include <dbus/dbus.h>

struct VeDbus *exportToDbus(char const *serviceName, struct VeItem *root)
{
	struct VeDbus *conn;

	logI("dbus_service", "export to Dbus %s", serviceName);

	conn = veDbusConnectString(veDbusGetDefaultConnectString());

	if (!conn)
	{
		logE("dbus_service", "no dbus connection");
		return NULL;
	}

	veDbusItemInit(conn, root);

	veDbusChangeName(conn, serviceName);

	return conn;
}
